package sk.seges.sesam.core.model.converter;

import java.io.Serializable;

import javax.annotation.Generated;
import javax.persistence.EntityManager;

import sk.seges.corpis.service.annotation.TransactionPropagationModel;
import sk.seges.sesam.dao.Page;
import sk.seges.sesam.dao.PagedResult;
import sk.seges.sesam.shared.model.converter.BasicCachedConverter;
import sk.seges.sesam.shared.model.converter.ConvertedInstanceCache;
import sk.seges.sesam.shared.model.converter.api.ConverterProvider;
import sk.seges.sesam.shared.model.converter.api.DtoConverter;
import sk.seges.sesam.shared.model.converter.api.InstantiableDtoConverter;
import sk.seges.sesam.utils.CastUtils;

@Generated(value = "sk.seges.corpis.pap.model.hibernate.HibernateTransferObjectConverterProcessor")
public class PagedResultConverter<DTO_T, DOMAIN_T> extends BasicCachedConverter<PagedResult<DTO_T>, PagedResult<DOMAIN_T>> {

	private EntityManager entityManager;

	private TransactionPropagationModel[] transactionPropagations;

	private ConverterProvider converterProvider;

	private ConvertedInstanceCache cache;

	public PagedResultConverter(EntityManager entityManager, TransactionPropagationModel[] transactionPropagations, ConverterProvider converterProvider, ConvertedInstanceCache cache) {
		super(cache);
		this.entityManager = entityManager;
		this.transactionPropagations = transactionPropagations;
		this.converterProvider = converterProvider;
		this.cache = cache;
	}

	public boolean equals(PagedResult<DOMAIN_T> _domain, PagedResult<DTO_T> _dto) {
		if (_domain.getPage() == null) {
			if (_dto.getPage() != null)
				return false;
		} else if (!_domain.getPage().equals(_dto.getPage()))
			return false;
		DtoConverter<DTO_T, DOMAIN_T> converterResult = (DtoConverter<DTO_T, DOMAIN_T>)converterProvider.getConverterForDomain(_domain.getResult(), cache);
		if (!converterResult.equals(_domain.getResult(),_dto.getResult()))
			return false;
		if (_domain.getTotalResultCount() != _dto.getTotalResultCount())
			return false;
		return true;
	}

	public PagedResult<DTO_T> createDtoInstance(Serializable id) {
		PagedResult<DTO_T> _result = new PagedResult<DTO_T>();
		return _result;
	}

	public PagedResult<DTO_T> toDto(PagedResult<DOMAIN_T> _domain) {

		if (_domain  == null) {
			return null;
		}

		PagedResult<DTO_T> _result = createDtoInstance(null);
		return convertToDto(_result, _domain);
	}

	public PagedResult<DTO_T> convertToDto(PagedResult<DTO_T> _result, PagedResult<DOMAIN_T> _domain) {

		if (_domain  == null) {
			return null;
		}

		InstantiableDtoConverter<Page, Page> converterPage = ensureDomainPageConverter((Page)_domain.getPage());
		_result.setPage(converterPage.toDto(CastUtils.cast((Page)_domain.getPage(), Page.class)));
		DtoConverter<DTO_T, DOMAIN_T> converterResult = (DtoConverter<DTO_T, DOMAIN_T>)converterProvider.getConverterForDomain(_domain.getResult(), cache);
		if (converterResult != null) {
			_result.setResult(converterResult.toDto(_domain.getResult()));
		} else {
			_result.setResult((DTO_T)_domain.getResult());
		}
		_result.setTotalResultCount(_domain.getTotalResultCount());
		return _result;
	}

	public PagedResult<DOMAIN_T> createDomainInstance(Serializable id) {
		if (id != null) {
			PagedResult<DOMAIN_T> _result = (PagedResult<DOMAIN_T>)entityManager.find(PagedResult.class, id);
			if (_result != null) {
				return _result;
			}
		}

		 return new PagedResult<DOMAIN_T>();
	}

	public PagedResult<DOMAIN_T> fromDto(PagedResult<DTO_T> _dto) {

		if (_dto == null) {
			return null;
		}

		PagedResult<DOMAIN_T> _result = createDomainInstance(null);

		return convertFromDto(_result, _dto);
	}

	public PagedResult<DOMAIN_T> convertFromDto(PagedResult<DOMAIN_T> _result, PagedResult<DTO_T> _dto) {

		if (_dto  == null) {
			return null;
		}

		InstantiableDtoConverter<Page, Page> converterPage = ensureDtoPageConverter(_dto.getPage());
		_result.setPage(CastUtils.cast((Page)converterPage.fromDto(_dto.getPage()), Page.class));
		DtoConverter<DTO_T, DOMAIN_T> converterResult = (DtoConverter<DTO_T, DOMAIN_T>)converterProvider.getConverterForDomain(_result.getResult(), cache);
		if (converterResult != null) {
			_result.setResult(converterResult.fromDto(_dto.getResult()));
		} else {
			_result.setResult((DOMAIN_T)_dto.getResult());
		}
		_result.setTotalResultCount(_dto.getTotalResultCount());
		return _result;
	}

	protected <DTO extends Page, DOMAIN extends Page> InstantiableDtoConverter<DTO, DOMAIN> ensureDomainPageConverter(Page obj) {
		if (obj == null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDomainPageConverter((Class<? extends Page>)null);
		}

		return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDomainPageConverter((Class<? extends Page>)obj.getClass());
	}
	
	protected <DTO extends Page, DOMAIN extends Page> InstantiableDtoConverter<DTO, DOMAIN> ensureDomainPageConverter(Class<? extends Page> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDomain(objClass, cache);
		if (converter != null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) converter;
		}
		return getDomainPageConverter(objClass);
	}

	protected <DTO extends Page, DOMAIN extends Page> InstantiableDtoConverter<DTO, DOMAIN> ensureDtoPageConverter(Page obj) {
		if (obj == null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDtoPageConverter((Class<? extends Page>)null);
		}

		return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDtoPageConverter((Class<? extends Page>)obj.getClass());
	}
	
	protected <DTO extends Page, DOMAIN extends Page> InstantiableDtoConverter<DTO, DOMAIN> ensureDtoPageConverter(Class<? extends Page> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDto(objClass, cache);
		if (converter != null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) converter;
		}
		return getDtoPageConverter(objClass);
	}

	protected <DTO extends Page, DOMAIN extends Page> InstantiableDtoConverter<DTO, DOMAIN> getDomainPageConverter(Class<? extends Page> objClass){
		return (InstantiableDtoConverter<DTO, DOMAIN>)new PageConverter(entityManager, transactionPropagations, converterProvider, cache);
	}

	protected <DTO extends Page, DOMAIN extends Page> InstantiableDtoConverter<DTO, DOMAIN> getDtoPageConverter(Class<? extends Page> objClass){
		return (InstantiableDtoConverter<DTO, DOMAIN>)new PageConverter(entityManager, transactionPropagations, converterProvider, cache);
	}

}